## rtw89 1.0.2

=== Makefile ===
SHELL := /bin/sh
KVER  ?= $(shell uname -r)
KSRC := /lib/modules/$(KVER)/build
FIRMWAREDIR := /lib/firmware/
PWD := $(shell pwd)
CLR_MODULE_FILES := *.mod.c *.mod *.o .*.cmd *.ko *~ .tmp_versions* modules.order Module.symvers
SYMBOL_FILE := Module.symvers
# Handle the move of the entire rtw88 tree
ifneq ("","$(wildcard /lib/modules/$(KVER)/kernel/drivers/net/wireless/realtek)")
MODDESTDIR := /lib/modules/$(KVER)/kernel/drivers/net/wireless/realtek/rtw89
else
MODDESTDIR := /lib/modules/$(KVER)/kernel/drivers/net/wireless/rtw89
endif
#Handle the compression option for modules in 3.18+
ifneq ("","$(wildcard $(MODDESTDIR)/*.ko.gz)")
COMPRESS_GZIP := y
endif
ifneq ("","$(wildcard $(MODDESTDIR)/*.ko.xz)")
COMPRESS_XZ := y
endif

EXTRA_CFLAGS += -O2
EXTRA_CFLAGS += -DCONFIG_RTW89_DEBUGMSG
EXTRA_CFLAGS += -DCONFIG_RTW89_DEBUGFS

obj-m += rtw89core.o
rtw89core-y +=  core.o \
		debug.o \
		mac80211.o \
		mac.o \
		phy.o \
		fw.o \
		rtw8852a.o \
		rtw8852a_table.o \
		rtw8852a_rfk.o \
		rtw8852a_rfk_table.o \
		cam.o \
		efuse.o \
		regd.o \
		coex.o \
		ps.o \
		sar.o \
		ser.o \
		util.o

obj-m += rtw89pci.o
rtw89pci-y := pci.o

ccflags-y += -D__CHECK_ENDIAN__

all: 
	$(MAKE) -C $(KSRC) M=$(PWD) modules
install: all
	@rm -f $(MODDESTDIR)/rtw89*.ko

	@mkdir -p $(MODDESTDIR)
	@install -p -D -m 644 *.ko $(MODDESTDIR)	
ifeq ($(COMPRESS_GZIP), y)
	@gzip -f $(MODDESTDIR)/*.ko
endif
ifeq ($(COMPRESS_XZ), y)
	@xz -f $(MODDESTDIR)/*.ko
endif
	@depmod -a $(KVER)

	cp *.bin /lib/firmware/rtw89/.

	@echo "Install rtw89 SUCCESS"

uninstall:
	@rm -f $(MODDESTDIR)/rtw89.ko

	@depmod -a
	
	@echo "Uninstall rtw89 SUCCESS"

clean:
	@rm -fr *.mod.c *.mod *.o .*.cmd .*.o.cmd *.ko *~ .*.o.d .cache.mk
	@rm -fr .tmp_versions
	@rm -fr Modules.symvers
	@rm -fr Module.symvers
	@rm -fr Module.markers
	@rm -fr modules.order

=== debian/changelog ===
rtw89 (1.0.2-1) unstable; urgency=medium

  * update

 -- lwfinger <Larry.Finger@lwfinger.net>  Tue, 27 Jul 2021 11:35:57 +0800

rtw89 (1.0.1-1) unstable; urgency=medium

  * fix Remove unnecessary dependencies.

 -- lichenggang <lichenggang@uniontech.com>  Wed, 23 Jun 2021 20:16:05 +0800

rtw89 (1.0.0-1) unstable; urgency=medium

  * Add driver package to build DEB package support in Debian DKMS format.

 -- lichenggang <lichenggang@uniontech.com>  Thu, 17 Jun 2021 17:14:07 +0800

## rtw89 1.0.3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-SHELL := /bin/sh
+SHELL := /bin/bash
 KVER  ?= $(shell uname -r)
 KSRC := /lib/modules/$(KVER)/build
 FIRMWAREDIR := /lib/firmware/
@@ -11,6 +11,7 @@
 else
 MODDESTDIR := /lib/modules/$(KVER)/kernel/drivers/net/wireless/rtw89
 endif
+
 #Handle the compression option for modules in 3.18+
 ifneq ("","$(wildcard $(MODDESTDIR)/*.ko.gz)")
 COMPRESS_GZIP := y
@@ -18,43 +19,56 @@
 ifneq ("","$(wildcard $(MODDESTDIR)/*.ko.xz)")
 COMPRESS_XZ := y
 endif
+ifeq ("","$(wildcard MOK.der)")
+NO_SKIP_SIGN := y
+endif
 
 EXTRA_CFLAGS += -O2
 EXTRA_CFLAGS += -DCONFIG_RTW89_DEBUGMSG
 EXTRA_CFLAGS += -DCONFIG_RTW89_DEBUGFS
+KEY_FILE ?= MOK.der
 
 obj-m += rtw89core.o
 rtw89core-y +=  core.o \
-		debug.o \
 		mac80211.o \
 		mac.o \
 		phy.o \
 		fw.o \
-		rtw8852a.o \
-		rtw8852a_table.o \
-		rtw8852a_rfk.o \
-		rtw8852a_rfk_table.o \
 		cam.o \
 		efuse.o \
 		regd.o \
+		sar.o \
 		coex.o \
 		ps.o \
-		sar.o \
-		ser.o \
-		util.o
+		debug.o \
+		ser.o
+
+obj-m += rtw_8852a.o
+rtw_8852a-y := rtw8852a.o \
+		    rtw8852a_table.o \
+		    rtw8852a_rfk.o \
+		    rtw8852a_rfk_table.o
+
+obj-m += rtw_8852ae.o
+rtw_8852ae-y := rtw8852ae.o
+
+#obj-m += rtw89debug.o
+#rtw89debug-y := debug.o
 
 obj-m += rtw89pci.o
 rtw89pci-y := pci.o
 
 ccflags-y += -D__CHECK_ENDIAN__
 
-all: 
+.PHONY: all install uninstall clean sign sign-install
+
+all:
 	$(MAKE) -C $(KSRC) M=$(PWD) modules
 install: all
 	@rm -f $(MODDESTDIR)/rtw89*.ko
 
 	@mkdir -p $(MODDESTDIR)
-	@install -p -D -m 644 *.ko $(MODDESTDIR)	
+	@install -p -D -m 644 *.ko $(MODDESTDIR)
 ifeq ($(COMPRESS_GZIP), y)
 	@gzip -f $(MODDESTDIR)/*.ko
 endif
@@ -63,15 +77,18 @@
 endif
 	@depmod -a $(KVER)
 
-	cp *.bin /lib/firmware/rtw89/.
+	@mkdir -p /lib/firmware/rtw89/
+	@cp rtw8852a_fw.bin /lib/firmware/rtw89/.
+	@mkdir -p /lib/firmware/rtl_bt/
+	@cp rtl8852au*.bin /lib/firmware/rtl_bt/.
 
 	@echo "Install rtw89 SUCCESS"
 
 uninstall:
-	@rm -f $(MODDESTDIR)/rtw89.ko
+	@rm -f $(MODDESTDIR)/rtw89*.ko
 
 	@depmod -a
-	
+
 	@echo "Uninstall rtw89 SUCCESS"
 
 clean:
@@ -81,3 +98,18 @@
 	@rm -fr Module.symvers
 	@rm -fr Module.markers
 	@rm -fr modules.order
+
+sign:
+ifeq ($(NO_SKIP_SIGN), y)
+	@openssl req -new -x509 -newkey rsa:2048 -keyout MOK.priv -outform DER -out MOK.der -nodes -days 36500 -subj "/CN=Custom MOK/"
+	@mokutil --import MOK.der
+else
+	echo "Skipping key creation"
+endif
+	@$(KSRC)/scripts/sign-file sha256 MOK.priv MOK.der rtw89core.ko
+	@$(KSRC)/scripts/sign-file sha256 MOK.priv MOK.der rtw89pci.ko
+	@$(KSRC)/scripts/sign-file sha256 MOK.priv MOK.der rtw_8852a.ko
+	@$(KSRC)/scripts/sign-file sha256 MOK.priv MOK.der rtw_8852ae.ko
+
+sign-install: all sign install
+

=== debian/changelog ===
rtw89 (1.0.3-1) unstable; urgency=medium

  * support linux 5.17.

 -- LiChengGang <lichenggang@uniontech.com>  Tue, 19 Apr 2022 13:41:03 +0800

=== debian/control ===
Source: rtw89
Section: misc
Priority: optional
Maintainer: lwfinger <Larry.Finger@lwfinger.net>
Build-Depends: debhelper (>= 11),
                dkms,
                bc,
                module-assistant
Standards-Version: 4.1.3
Vcs-Browser: https://github.com/lwfinger/rtlrtw89
Vcs-Git: https://github.com/lwfinger/rtlrtw89.git

Package: rtw89-dkms
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DKMS files to build and install rtl8852be
 The rtl8852ae driver provides the driver for USB wifi adapter.
 This package contains the DKMS files to build and install rtl8852be.
 To install this package, you have to install the header files for your
 current kernel manually (usually included in the "linux-headers-<your
 architecture>").

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

VERSION ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+).*$$/\1/p')

%:
	dh $@ --with dkms

override_dh_auto_install:
	dh_install -prtw89-dkms *.c *.h *.bin *.md 					usr/src/rtw89-$(VERSION)
	dh_install -prtw89-dkms LICENSE 					        usr/src/rtw89-$(VERSION)
	dh_install -prtw89-dkms Makefile 					        usr/src/rtw89-$(VERSION)
	dh_install -prtw89-dkms debian/dkms.conf					usr/src/rtw89-$(VERSION)

override_dh_dkms:
	dh_dkms -V

override_dh_auto_build:
	:
